Description
| recently tried a module from the puppet forge (for bacula)

The module included some paramaterized classes. When | importe the environment, the classes were imported correctly.
Upon reviewing the module, | decided | din't care for it, and decided to write my own.

The new module didn't use any paramaterized classes. However, even when re-importing the environment puppet would error out.
It complained about things that were defined as paramaterized values.

The only way | was able to work around it was to move my module out of the puppet directory, import the env (where foreman
cleaned up everything) then move my new module back and re-import the environment.

Steps to reproduce:
#1) Install a module with paramaterized classes
#2) Import environments
#3) Set a few of the paramaters (I set them globally. | assume it'd work at the hostgroup, domain, or host level as well)
#4) Remove the module with paramaterized classes
#5) Replace with a module using the same class names, but without them being paramaterized.
6) Import environments
)

7) Initiate a puppet run

| did not look at the hosts YAML output. | suspect that the resulting yaml file is still putting the paramaterized bits in play.

Related issues:

Related to Foreman - Bug #7517: Puppet class parameter not removed from envir... Closed 09/18/2014
Has duplicate Foreman - Bug #6859: Foreman not removing old class parameters Duplicate 07/31/2014
History

#1 - 04/02/2013 12:51 PM - Dominic Cleal

- Subject changed from paramaterized classes can persist in odd instances to Paramaterized classes persist through import after parameters have
been removed

- Assignee deleted (Ohad Levy)

#2 - 09/22/2014 06:10 AM - Dominic Cleal

- Has duplicate Bug #6859: Foreman not removing old class parameters added

#3 - 09/22/2014 06:11 AM - Dominic Cleal

- Related to Bug #7517: Puppet class parameter not removed from environment after an import added

#4 - 10/30/2014 05:04 AM - Jeff Sault

Is there any plans to fix this bug?

#5 - 02/12/2015 04:58 AM - Jeff Sault
https://projects.theforeman.org/issues/2
https://projects.theforeman.org/issues/6
https://projects.theforeman.org/issues/7

This is turning into a big problem for us. With our deployments we tend to have different versions of the same class in different environments.
Whenever we remove a parameter from a new version of a class, puppet complains that an unknown parameter is being passed to the class.
Ive been working on implementing workarounds using the foreman API but its a nightmare...

- It seems its not possible to remove a smart class parameter from a class for a specific environment, its all or nothing, the parameter gets removed
from all instances of the class, in all environments.

- If the class is removed from the environment then re-imported (as described above) then all the previously overridden parameters are orphaned.
They show in the host/hostgroup parameters pages but the class field is empty. Theres no way that | can find to find these parameters via the API to
re-associate them with the classes.

Are there any other workaround which | havent thought of? Or plans to fix the issue?

#6 - 05/05/2015 11:07 AM - Dominic Cleal

- Related to Bug #10377: Re-importing an environment where class parameters were removed does not remove those parameters in Foreman's class
signatures added

#7 - 11/24/2015 04:57 AM - Dominic Cleal

- Related to Bug #12579: Class Parameters are not separated for different environments added

#8 - 11/24/2015 06:51 AM - Dominic Cleal

- Related to deleted (Bug #10377: Re-importing an environment where class parameters were removed does not remove those parameters in
Foreman'’s class signatures)

#9 - 11/24/2015 06:51 AM - Dominic Cleal

- Related to deleted (Bug #12579: Class Parameters are not separated for different environments)

#10 - 12/07/2016 05:47 PM - Chris Edester

This issue seems related:
| can find no way to delete Smart class parameters.

After deleting all of my Puppet classes, all the orphaned Smart class parameters are left with no Puppet class association. Is there any way to purge
the left over Smart class parameters? Shoudn't they be deleted with their respective Puppet classes?
